<template>
  <v-menu
    ref="menu"
    v-model="menu"
    :close-on-content-click="false"
    transition="scale-transition"
    offset-y
    min-width="290px"
  >
    <template v-slot:activator="{ on, attrs }">
      <v-text-field
        v-bind="attrs"
        v-on="on"
        outlined
        :value="field.display && field.display(v) || v"
        readonly
        :prepend-icon="field.icon"
        :name="field.id"
        :label="field.name"
      ></v-text-field>
    </template>

    <validation-provider
      v-slot="{ errors }"
      :name="field.name"
      :rules="field.rules"
    >
      <v-date-picker
        :key="`date-input-${field.id}`"
        ref='picker'
        v-model="v"
        :error-messages="errors"
        no-title
        scrollable
      />
    </validation-provider>
  </v-menu>
</template>

<script lang="ts">
import Vue from 'vue'
import { ValidationProvider } from 'vee-validate'

export default Vue.extend({
  name: 'date-field',
  components: { ValidationProvider },
  props: {
    field: { type: Object, required: true },
    value: { type: String }
  },
  data () {
    return {
      menu: false
    }
  },
  computed: {
    v: {
      get (): string {
        return this.value
      },
      set (v: string) {
        this.menu = false
        this.$emit('input', v)
      }
    }
  }
})
</script>
